package state;

import java.util.Date;

public class Client {
    public static void main(String[] args) {

        // Subscription policies setup
        Subscription.statesSetup(
                new Active(),
                new Late(),
                new Recovering(),
                new Overdue(),
                new Suspended()
        );

        // Cria uma nova assinatura com a data de vencimento no dia atual do mês.
        Subscription subscription = new Subscription(29.00f, new Date(2020, 7, 6));

        System.out.println("\nAfter subscription start:");
        System.out.println("Total to pay: " + subscription.calculateSubscriptionValue());
        System.out.println("Receiving content? " + subscription.sendContent());

        System.out.println("\nDay after due date:");
        subscription.setSubscriptionLate();
        System.out.println("Total to pay: " + subscription.calculateSubscriptionValue());
        System.out.println("Receiving content? " + subscription.sendContent());

        System.out.println("\n6 days after due date:");
        subscription.setSubscriptionRecovering(0.05f);
        System.out.println("Total to pay: " + subscription.calculateSubscriptionValue());
        System.out.println("Receiving content? " + subscription.sendContent());

        System.out.println("\n11 days after due date:");
        subscription.setSubscriptionOverdue(new Date(2020, 7, 17)); // Data de hoje
        System.out.println("Total to pay: " + subscription.calculateSubscriptionValue());
        System.out.println("Receiving content? " + subscription.sendContent());

        System.out.println("\nAfter suspending subscription:");
        subscription.suspendSubscription(new Date(2020, 7, 25));
        System.out.println("Total to pay: " + subscription.calculateSubscriptionValue());
        System.out.println("Receiving content? " + subscription.sendContent());

        // Após a realização do pagamento é definido o novo prazo
        subscription.setDueDate(new Date(2020, 8, 6));
        subscription.activateSubscription();
    }
}