package state;

import java.util.Date;
import java.util.concurrent.TimeUnit;

public class Suspended implements Situation {
    // No estado "Suspenso", é necessário saber a data do vencimento e a data da suspensão
    // da assinatura para calcular o valor a ser pago.

    public float calculateSubscriptionValue(Subscription context){
        // Cálculo de dias entre o vencimento e o cancelamento da assinatura
        long totalDays = context.getSuspensionDate().getTime() - context.getDueDate().getTime();
        totalDays = TimeUnit.DAYS.convert(totalDays, TimeUnit.MILLISECONDS);

        return context.getPlanValue() + 0.1f* context.getPlanValue() *totalDays;
    }
}